var url_mappings= {
 "comment": "#CV, weblink, CC_Restriction, taxidpostfix",
 "html_acc": [
     {"cv": "AC", "weblink": "http://pmn.plantcyc.org/ARA/NEW-IMAGE?type=NIL&object=", "cc_restriction": ""},
     {"cv": "AspGD", "weblink": "http://www.aspergillusgenome.org/cgi-bin/locus.pl?dbid=", "cc_restriction": ""},
     {"cv": "CHEBI", "weblink": "http://www.ebi.ac.uk/chebi/searchId.do?chebiId=", "cc_restriction": ""},
     {"cv": "CHEMBL", "weblink": "https://www.ebi.ac.uk/chembldb/compound/inspect/", "cc_restriction": ""},
     {"cv": "CHEMBLASSAY", "weblink": "https://www.ebi.ac.uk/chembldb/assay/inspect/", "cc_restriction": ""},
     {"cv": "CHEMBLTARGET", "weblink": "https://www.ebi.ac.uk/chembldb/target/inspect/", "cc_restriction": ""},
     {"cv": "CO", "weblink": "http://www.cropontology.org/terms/CO_321:", "cc_restriction": ""},
     {"cv": "DOI", "weblink": "http://dx.doi.org/", "cc_restriction": ""},
     {"cv": "DrugBank", "weblink": "https://www.drugbank.ca/drugs/", "cc_restriction": ""},
     {"cv": "EC", "weblink": "http://www.expasy.org/enzyme/", "cc_restriction": ""},
     {"cv": "EMBL", "weblink": "http://www.ebi.ac.uk/ena/data/view/", "cc_restriction": ""},
     {"cv": "ENSEMBL", "weblink": "http://plants.ensembl.org/Search/Results?q=", "cc_restriction": ""},
     {"cv": "ENSV", "weblink": "http://plants.ensembl.org/Search/Results?q=", "cc_restriction": ""},
     {"cv": "ENSEMBL-MOUSE", "weblink": "http://www.ensembl.org/Mus_musculus/Gene/Summary?db=core;g=", "cc_restriction": ""},
     {"cv": "EBI-GXA", "weblink": "https://www.ebi.ac.uk/gxa/experiments/", "cc_restriction": ""},
     {"cv": "GENB", "weblink": "http://www.ncbi.nlm.nih.gov/sites/entrez?db=nuccore&cmd=search&term=", "cc_restriction": ""},
     {"cv": "GENOSCOPE", "weblink": "http://www.genoscope.cns.fr/brassicanapus/cgi-bin/gbrowse/colza/?name=", "cc_restriction": ""},
     {"cv": "GO", "weblink": "http://www.ebi.ac.uk/QuickGO/term/", "cc_restriction": ""},
     {"cv": "INTACT", "weblink": "http://www.ebi.ac.uk/intact/pages/interactions/interactions.xhtml?query=", "cc_restriction": ""},
     {"cv": "IPRO", "weblink": "http://www.ebi.ac.uk/interpro/IEntry?ac=", "cc_restriction": ""},
     {"cv": "KEGG", "weblink": "http://www.genome.jp/dbget-bin/www_bget?cpd:", "cc_restriction": "Comp"},
     {"cv": "MC", "weblink": "http://metacyc.org/META/substring-search?type=NIL&object=", "cc_restriction": ""},
     {"cv": "NC_GE", "weblink": "http://www.ncbi.nlm.nih.gov/sites/entrez?db=gene&term=", "cc_restriction": ""},
     {"cv": "NC_NM", "weblink": "http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?id=", "cc_restriction": ""},
     {"cv": "NC_NP", "weblink": "http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=protein&id=", "cc_restriction": ""},
     {"cv": "NLM", "weblink": "http://www.ncbi.nlm.nih.gov/pubmed/", "cc_restriction": ""},
     {"cv": "OMIM", "weblink": "http://omim.org/entry/", "cc_restriction": ""},
     {"cv": "PDB", "weblink": "http://www.rcsb.org/pdb/explore/explore.do?structureId=", "cc_restriction": ""},
     {"cv": "PFAM", "weblink": "http://pfam.sanger.ac.uk/family/", "cc_restriction": ""},
     {"cv": "PlnTFDB", "weblink": "http://plntfdb.bio.uni-potsdam.de/v3.0/get_id.php?seq_id=", "cc_restriction": ""},
     {"cv": "PMID", "weblink": "http://www.ncbi.nlm.nih.gov/pubmed/", "cc_restriction": ""},
     {"cv": "PO", "weblink": "http://purl.obolibrary.org/obo/PO_", "cc_restriction": ""},
     {"cv": "Poplar-JGI", "weblink": "http://genome.jgi-psf.org/cgi-bin/dispGeneModel?db=Poptr1_1&id=", "cc_restriction": ""},
     {"cv": "PoplarCyc", "weblink": "http://pmn.plantcyc.org/POPLAR/NEW-IMAGE?object=", "cc_restriction": ""},
     {"cv": "PRINTS", "weblink": "http://www.bioinf.manchester.ac.uk/cgi-bin/dbbrowser/PRINTS/DoPRINTS.pl?cmd_a=Display&fun_a=Text&qst_a=", "cc_restriction": ""},
     {"cv": "PRODOM", "weblink": "http://prodom.prabi.fr/prodom/current/cgi-bin/request.pl?question=DBEN&query=", "cc_restriction": ""},
     {"cv": "PROSITE", "weblink": "http://www.expasy.org/prosite/", "cc_restriction": ""},
     {"cv": "PUBCHEM", "weblink": "http://pubchem.ncbi.nlm.nih.gov/summary/summary.cgi?cid=", "cc_restriction": ""},
     {"cv": "PubMed", "weblink": "http://www.ncbi.nlm.nih.gov/pubmed/", "cc_restriction": ""},
     {"cv": "REAC", "weblink": "http://www.reactome.org/entitylevelview/PathwayBrowser.html#DB=gk_current&ID=", "cc_restriction": ""},
     {"cv": "SCOP", "weblink": "http://scop.mrc-lmb.cam.ac.uk/scop/search.cgi?sid=", "cc_restriction": ""},
     {"cv": "SGD", "weblink": "http://www.yeastgenome.org/locus/", "cc_restriction": ""},
     {"cv": "SOYCYC", "weblink": "http://www.soybase.org:8082/SOY/NEW-IMAGE?type=COMPOUND&object=", "cc_restriction": "Comp"},
     {"cv": "SOYCYC", "weblink": "http://www.soybase.org:8082/SOY/NEW-IMAGE?type=PATHWAY&object=", "cc_restriction": "Path"},
     {"cv": "SOYCYC", "weblink": "http://www.soybase.org:8082/SOY/NEW-IMAGE?type=REACTION&object=", "cc_restriction": "Reaction"},
     {"cv": "TAIR", "weblink": "http://www.arabidopsis.org/servlets/TairObject?type=locus&name=", "cc_restriction": ""},
     {"cv": "TO", "weblink": "http://purl.obolibrary.org/obo/TO_", "cc_restriction": ""},
     {"cv": "TX", "weblink": "http://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi?mode=Info&id=", "cc_restriction": ""},
     {"cv": "UNIPROTKB", "weblink": "http://www.uniprot.org/uniprot/", "cc_restriction": ""},
     {"cv": "YeastCyc", "weblink": "https://yeast.biocyc.org/YEAST/NEW-IMAGE?type=NIL&object=", "cc_restriction": ""}
 ]
};
